#!/usr/bin/perl -I/usr/sausalito/perl
# Copyright 2001 Sun Microsystems, Inc.  All rights reserved.
# $Id: gen_adm_cert.pl,v 1.2.2.1 2002/01/14 20:52:30 pbaltz Exp $
#
# Make sure an ssl cert exists for the admin server.

use strict;
use lib qw(/usr/sausalito/perl);
use CCE;

if (-e '/etc/admserv/certs/certificate') {
	exit(0);
}

my $cce = new CCE;
$cce->connectuds();

# find the system object
my ($sys_oid) = $cce->find('System');
my ($ok, $sys) = $cce->get($sys_oid);

#
# FIXME: This checks to make sure the number of days valid for the default
# 	 cert doesn't push past the y2038 bug barrier (rollover because time
#	 is only 4 bytes in C).  This should be removed if/when the y2038 bug
#	 is fixed.  This will occur in about 9 years or so as of 1/14/2002, and
#	 more than likely this script will no longer be in use.  Hey, I was
#	 bored.
#
my $days_valid = 9999;
my $current_time = time();
my $expire_time = $current_time + ($days_valid * 24 * 60 * 60);
my $bug_time = (2 ** 31) - 100;  # T-100 seconds to avoid race conditions
my $difference = $bug_time - $expire_time;

if ($difference < 0) {
	# need to correct days valid
	$days_valid += int($difference / (24 * 60 * 60));
}

# set up ssl
($ok) = $cce->set($sys_oid, 'SSL',
		  {
			'createCert' => time(),
			'daysValid' => $days_valid,
			'country' => 'SS',
			'state' => 'SS',
			'city' => 'Generic',
			'orgName' => 'Sun Cobalt'
		  });
$cce->bye();
exit(0);
